const {Row, Col, Button, message, Table, Select, Spin, InputNumber, Tree, Input, Modal} = antd;
const TreeNode = Tree.TreeNode;

var newList = [

];

var newTreeData = [

];

class ParamsTable extends React.Component {

    constructor(props) {
        super(props);
        var today = new Date();
        var currDate = today.getFullYear() + '/' + (today.getMonth() + 1) + '/' + today.getDate();
        var currDay = this.getWeekday(today.getDay())   //(0-6，0代表星期天)

        this.state = {
            currDate: currDate,
            currDay: currDay,
            list: [],//数据列表
            targetId: "",
            spinning: true,
            visible: false,
            loading: false,
            editData: {},
            treeData: [],
        };
    }

    componentDidMount() {
        var list = [];
        var treeData = [];

        $.ajax({
                   url: '/api/public/paramManageView/paramManageApi/getList',
                   type: "get",
                   data: {tableName: "antcorps_parammanage"},
                   dataType: "json",
                   async: false,
                   success: function (res) {
                       console.info("初始化res：", res);
                       list = res.data.list;
                       treeData = res.data.treeColumns;
                   }
               });

        this.setState(
            {
                list: list,
                treeData: treeData,
                columns: this.getColumns(),
                spinning: false
            }
        );
    }

    componentWillUnmount() {

    }

    getWeekday = (day) => {
        var weekday = new Array(7)
        weekday[0] = "星期天";
        weekday[1] = "星期一";
        weekday[2] = "星期二";
        weekday[3] = "星期三";
        weekday[4] = "星期四";
        weekday[5] = "星期五";
        weekday[6] = "星期六";
        return weekday[day]
    }

    getColumns = () => {
        const columns = [
            {
                title: '组名',
                dataIndex: 'mainLabel',
                key: 'mainLabel',
                width: 80,
                className: 'table-column',
            }, {
                title: '显示名',
                dataIndex: 'label',
                key: 'label',
                width: 120,
                className: 'table-column',
                /*render: (text, data) => {
                    return <textarea id={`label_${data.id}`}>{data.label}</textarea>
                }*/
            }, {
                title: '参数名',
                dataIndex: 'fieldName',
                key: 'fieldName',
                width: 110,
                className: 'table-column',
            }, {
                title: '参数值',
                dataIndex: 'value',
                key: 'value',
                width: 110,
                className: 'table-column font_bg',
                /*render: (text, data) => {
                    return <textarea id={`paramValue_${data.id}`}>{data.value}</textarea>
                }*/
            },
            {
                title: '操作',
                dataIndex: 'operate',
                key: 'operate',
                width: 60,
                className: 'table-column table-column-center',
                render: (text, data) => {
                    return <p style={{cursor: 'pointer', color: 'rgb(0, 141, 247)'}}
                              onClick={() => {
                                  this.showModal(data)
                              }}>编辑</p>
                }
            }
        ];

        return columns;
    }

    showModal = (data) => {
        console.info("data", data);
        $("#label_" + data.id).val(data.value);

        this.setState(
            {
                visible: true,
                editData: data,
            }
        );
    }

    onSelect = (key) => {
        var list = [];
        $.ajax({
                   url: '/api/public/paramManageView/paramManageApi/getList',
                   type: "get",
                   data: {
                       tableName: "antcorps_parammanage",
                       id: key.toString()
                   },
                   dataType: "json",
                   async: false,
                   success: function (res) {
                       console.info("res:", res);
                       list = res.data.list;
                   }
               });

        this.setState(
            {
                list: list,
                targetId: key.toString(),
                spinning: false
            }
        );
    };

    handleOk = () => {
        const {editData, targetId} = this.state;

        var label = $("#edit_label_" + editData.id).val();
        var paramValue = $("#edit_paramValue_" + editData.id).val();

        $.ajax({
                   url: '/api/public/paramManageView/paramManageApi/updateInfo',
                   type: "post",
                   data: {
                       tableName: "antcorps_parammanage",
                       id: editData.id,
                       label: label,
                       paramValue: paramValue,
                   },
                   dataType: "json",
                   async: false,
                   success: function (res) {
                       console.info("res:", res);
                   }
               });

        this.onSelect(targetId);
        this.setState(
            {
                visible: false,
                loading: false,
            }
        );
    }

    handleCancel = () => {
        this.setState({visible: false});
    }

    render() {
        const {list, columns, spinning, currDate, currDay, editData, visible, loading} = this.state;

        const loop = data => data.map((item) => {
            if (item.children) {
                return <TreeNode title={item.name} key={item.key}>{loop(item.children)}</TreeNode>;
            }
            return <TreeNode title={item.name} key={item.key} isLeaf={item.isLeaf}
                             disabled={item.key === '0-0-0'}/>;
        });
        const treeNodes = loop(this.state.treeData.length > 0 ? this.state.treeData : newTreeData);

        return (
            <div id={"paramsTableWrap"} style={{
                width: '100%',
                height: document.body.clientHeight - 2,
                // background: 'rgb(8,6,30)'
            }}>
                <div id="topDiv">
                    <div className="floatLeft topTitle">参数管理功能</div>
                    <div className="floatLeft topDate">{currDate} {currDay}</div>
                </div>
                {/* 内容 */}
                <div id="content">
                    <Row style={{height: '100%'}}>
                        {/* 左边树 */}
                        <Col span={6} className={'content_leftTree'}>
                            <Tree onSelect={this.onSelect} loadData={this.onLoadData} defaultExpandAll={true}>
                                {treeNodes}
                            </Tree>
                        </Col>
                        {/* 右边内容 */}
                        <Col span={18} className={'content_rightTree'}>
                            <Spin spinning={spinning} tip="正在加载数据...">
                                <Table style={{padding: 0}} columns={columns}
                                       dataSource={list.length > 0 ? list : newList}
                                       hasOrder={false}
                                       needScroll={true} pagination={false}
                                       bordered={false} size="small" scroll={{}}
                                />
                            </Spin>
                        </Col>
                    </Row>
                </div>
                <Modal title="编辑参数" visible={visible}
                       onOk={() => {
                           this.setState({loading: true,});
                           this.handleOk()
                       }}
                       onCancel={this.handleCancel}
                       footer={[
                           <Button key="submit" type="primary" size="large"
                                   loading={loading} onClick={() => {
                               this.setState({loading: true,});
                               this.handleOk()
                           }}>
                               提 交
                           </Button>,
                           <Button key="back" type="ghost" size="large" onClick={this.handleCancel}>
                               返 回
                           </Button>,
                       ]}
                >
                    {editData == null ? {} :
                     <div id={"paramModalDiv"}>
                         <p>
                             <div className={"floatLeft"}>组名：</div>
                             <div className={"floatLeft"}>{editData.mainLabel}</div>
                         </p>
                         <p>
                             <div className={"floatLeft"}>显示名：</div>
                             <textarea className={"floatLeft"}
                                       id={`edit_label_${editData.id}`}>{editData.label}</textarea>
                         </p>
                         <p>
                             <div className={"floatLeft"}>参数名：</div>
                             <div className={"floatLeft"}>{editData.fieldName}</div>
                         </p>
                         <p>
                             <div className={"floatLeft"}>参数值：</div>
                             <textarea className={"floatLeft"}
                                       id={`edit_paramValue_${editData.id}`}>{editData.value}</textarea>
                         </p>
                     </div>
                    }
                </Modal>
            </div>
        );
    }
}

ReactDOM.render(
    <ParamsTable/>,
    document
        .getElementById(
            'example'
        )
);

